One data grid for JavaScript, React, Vue & Angular. Sorting, filtering, virtualization, pinning, and CSV export included. Early access $199 $349 → [Get it now]

How to build a Kanban board in Angular

Building a functional and performant Kanban board in Angular is a common requirement for project management and CRM applications. As the creator of CoreUI, I have built dozens of drag-and-drop interfaces for enterprise-grade dashboards. The most efficient and modern solution is to leverage the @angular/cdk/drag-drop module, which handles the complex physics and accessibility of moving items between lists. By combining this with CoreUI components, you can create a board that is both highly functional and visually polished.

Use the Angular CDK DragDropModule to manage task movement between columns and cdkDropListGroup to link lists together.

1. Install and Import CDK

First, ensure you have the Angular CDK installed in your project. If you are starting fresh, you can check our guide on how to create a new Angular project.

npm install @angular/cdk

The CDK provides the DragDropModule which handles all the drag-and-drop physics and accessibility. CoreUI components are used for the card styling and layout grid.

2. Define the Board Data Structure

A Kanban board typically consists of several columns, each containing an array of tasks. Keeping your data model clean is essential for performance.

// kanban.component.ts
import { Component } from '@angular/core'
import { CommonModule } from '@angular/common'
import {
  CdkDragDrop,
  DragDropModule,
  moveItemInArray,
  transferArrayItem
} from '@angular/cdk/drag-drop'
import { CardModule, GridModule, ContainerComponent } from '@coreui/angular'

@Component({
  selector: 'app-kanban',
  standalone: true,
  imports: [CommonModule, DragDropModule, CardModule, GridModule, ContainerComponent],
  templateUrl: './kanban.component.html',
  styleUrls: ['./kanban.component.scss']
})
export class KanbanComponent {
  todo = ['Setup project', 'Install CoreUI', 'Review PRs']
  inProgress = ['Developing Kanban', 'Testing API']
  done = ['Initial commit', 'Documentation']

  drop(event: CdkDragDrop<string[]>) {
    if (event.previousContainer === event.container) {
      moveItemInArray(
        event.container.data,
        event.previousIndex,
        event.currentIndex
      )
    } else {
      transferArrayItem(
        event.previousContainer.data,
        event.container.data,
        event.previousIndex,
        event.currentIndex
      )
    }
  }
}

The drop method is the brain of the operation. It detects whether an item was moved within the same list or transferred to a different column.

3. Creating the Kanban Template

We use cdkDropListGroup to automatically link all drop lists within the container. We also utilize CoreUI Cards for a professional look.

<!-- kanban.component.html -->
<div class="kanban-wrapper" cdkDropListGroup>
  <div class="kanban-column">
    <h3>To Do</h3>
    <div
      cdkDropList
      [cdkDropListData]="todo"
      (cdkDropListDropped)="drop($event)"
      class="kanban-list"
    >
      <c-card *ngFor="let item of todo" cdkDrag class="kanban-item">
        <c-card-body>{{ item }}</c-card-body>
      </c-card>
    </div>
  </div>

  <div class="kanban-column">
    <h3>In Progress</h3>
    <div
      cdkDropList
      [cdkDropListData]="inProgress"
      (cdkDropListDropped)="drop($event)"
      class="kanban-list"
    >
      <c-card *ngFor="let item of inProgress" cdkDrag class="kanban-item">
        <c-card-body>{{ item }}</c-card-body>
      </c-card>
    </div>
  </div>

  <div class="kanban-column">
    <h3>Done</h3>
    <div
      cdkDropList
      [cdkDropListData]="done"
      (cdkDropListDropped)="drop($event)"
      class="kanban-list"
    >
      <c-card *ngFor="let item of done" cdkDrag class="kanban-item">
        <c-card-body>{{ item }}</c-card-body>
      </c-card>
    </div>
  </div>
</div>

The cdkDropList directive identifies a droppable area, while cdkDrag marks the individual cards as draggable elements.

4. Styling the Board Layout

For a proper Kanban feel, we need a horizontal layout that allows columns to scroll if they exceed the screen width.

// kanban.component.scss
.kanban-wrapper {
  display: flex;
  gap: 1.5rem;
  padding: 1rem;
  overflow-x: auto;
  align-items: flex-start;
}

.kanban-column {
  background: #f8f9fa;
  border-radius: 8px;
  width: 300px;
  min-width: 300px;
  padding: 1rem;
}

.kanban-list {
  min-height: 200px;
  display: block;
}

.kanban-item {
  margin-bottom: 0.75rem;
  cursor: grab;
  &:active {
    cursor: grabbing;
  }
}

.cdk-drag-preview {
  box-sizing: border-box;
  border-radius: 4px;
  box-shadow: 0 5px 15px rgba(0,0,0,0.15);
}

These styles ensure the columns stay side-by-side and provide the user with clear visual feedback during the drag interaction.

5. Enhancing with CoreUI Templates

For large-scale applications, you might want to integrate this Kanban board into a full dashboard environment. Using the Angular Dashboard Template provides you with pre-built navigation, headers, and state management that can wrap your Kanban component seamlessly.

<!-- Integration example -->
<c-container breakpoint="fluid">
  <c-row>
    <c-col>
      <app-kanban></app-kanban>
    </c-col>
  </c-row>
</c-container>

This ensures your board fits perfectly within the rest of your admin panel’s design system.

6. Handling Empty Columns

One common issue is losing the ability to drop an item into an empty column. We solve this by ensuring the list container has a minimum height and padding.

/* Ensure empty lists can still receive items */
.kanban-list {
  min-height: 400px;
  border: 2px dashed transparent;
  transition: border-color 0.2s ease;
}

.cdk-drop-list-dragging .kanban-list {
  border-color: #dee2e6;
}

By adding a dashed border during the drag operation, you guide the user to valid drop targets, improving the overall UX.

7. Performance and Optimization

When dealing with hundreds of tasks, you should implement trackBy in your *ngFor loops to prevent unnecessary DOM re-rendering.

// In your component
trackByFn(index: number, item: any) {
  return index // or item.id
}

// In your HTML
// <c-card *ngFor="let item of todo; trackBy: trackByFn" cdkDrag>

This is the same approach we use in CoreUI components like the Smart Table to ensure smooth performance regardless of data size.

Best Practice Note:

Always persist the new order of items to your backend database after the drop event completes. For a complete enterprise solution, consider using our Free Angular Admin Template which includes all the scaffolding needed for stateful applications. Avoid over-complicating the drag logic; the CDK’s built-in moveItemInArray and transferArrayItem are highly optimized for these specific use cases.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
What is the difference between typeof and instanceof in JavaScript
What is the difference between typeof and instanceof in JavaScript

How to conditionally add attributes to React components
How to conditionally add attributes to React components

How to force a React component to re-render
How to force a React component to re-render

What are the three dots `...` in JavaScript do?
What are the three dots `...` in JavaScript do?

One data grid for JavaScript, React, Vue & Angular. Sorting, filtering, virtualization, pinning, and CSV export included. Early access $199 $349 → [Get it now]

How to build a Kanban board in React

A Kanban board organizes tasks into columns representing workflow stages, with drag-and-drop for moving cards between them. As the creator of CoreUI, I’ve built Kanban-style interfaces for project management tools, sprint planners, and support ticket systems. The most effective approach stores board state as a map of column IDs to card arrays, uses HTML5 drag-and-drop for movement, and rerenders on every drop. This provides a functional board without heavy dependencies.

Create the board structure with columns and draggable cards.

import { useState } from 'react'

const INITIAL_BOARD = {
  todo: {
    title: 'To Do',
    cards: [
      { id: 'c1', text: 'Design mockups' },
      { id: 'c2', text: 'Write tests' }
    ]
  },
  inProgress: {
    title: 'In Progress',
    cards: [
      { id: 'c3', text: 'Implement API' }
    ]
  },
  done: {
    title: 'Done',
    cards: [
      { id: 'c4', text: 'Set up project' }
    ]
  }
}

function KanbanBoard() {
  const [board, setBoard] = useState(INITIAL_BOARD)
  const [dragging, setDragging] = useState(null)

  const onDragStart = (cardId, fromColumn) => {
    setDragging({ cardId, fromColumn })
  }

  const onDrop = (toColumn) => {
    if (!dragging || dragging.fromColumn === toColumn) return

    const { cardId, fromColumn } = dragging
    const card = board[fromColumn].cards.find(c => c.id === cardId)

    setBoard(prev => ({
      ...prev,
      [fromColumn]: {
        ...prev[fromColumn],
        cards: prev[fromColumn].cards.filter(c => c.id !== cardId)
      },
      [toColumn]: {
        ...prev[toColumn],
        cards: [...prev[toColumn].cards, card]
      }
    }))
    setDragging(null)
  }

  return (
    <div style={{ display: 'flex', gap: '1rem' }}>
      {Object.entries(board).map(([colId, col]) => (
        <KanbanColumn
          key={colId}
          colId={colId}
          column={col}
          onDragStart={onDragStart}
          onDrop={onDrop}
        />
      ))}
    </div>
  )
}

The board state maps column IDs to column objects containing title and cards array. dragging tracks the card being moved and its source column. On drop, the card is removed from the source and added to the destination.

Building the Column Component

Handle drop events and render cards.

function KanbanColumn({ colId, column, onDragStart, onDrop }) {
  const [isOver, setIsOver] = useState(false)

  return (
    <div
      onDragOver={(e) => { e.preventDefault(); setIsOver(true) }}
      onDragLeave={() => setIsOver(false)}
      onDrop={() => { onDrop(colId); setIsOver(false) }}
      style={{
        width: 280,
        minHeight: 400,
        background: isOver ? '#e8f4fd' : '#f4f5f7',
        borderRadius: 8,
        padding: '1rem',
        border: isOver ? '2px dashed #3498db' : '2px solid transparent'
      }}
    >
      <h3>{column.title} <span>({column.cards.length})</span></h3>
      {column.cards.map(card => (
        <KanbanCard
          key={card.id}
          card={card}
          colId={colId}
          onDragStart={onDragStart}
        />
      ))}
    </div>
  )
}

onDragOver must call preventDefault() to allow dropping. isOver highlights the column during drag. The card count shows in the header. The visual feedback makes it clear where the card will land.

Building the Card Component

Make cards draggable.

function KanbanCard({ card, colId, onDragStart }) {
  return (
    <div
      draggable
      onDragStart={() => onDragStart(card.id, colId)}
      style={{
        background: 'white',
        borderRadius: 4,
        padding: '0.75rem',
        marginBottom: '0.5rem',
        boxShadow: '0 1px 3px rgba(0,0,0,0.1)',
        cursor: 'grab'
      }}
    >
      {card.text}
    </div>
  )
}

The draggable attribute enables HTML5 drag-and-drop. onDragStart records the card and source column. The grab cursor signals the card is draggable.

Adding New Cards

Allow users to add tasks to columns.

function KanbanColumn({ colId, column, onDragStart, onDrop, onAddCard }) {
  const [adding, setAdding] = useState(false)
  const [text, setText] = useState('')

  const handleAdd = () => {
    if (text.trim()) {
      onAddCard(colId, text.trim())
      setText('')
      setAdding(false)
    }
  }

  return (
    <div /* ...drag props */ >
      <h3>{column.title}</h3>
      {column.cards.map(card => <KanbanCard key={card.id} card={card} colId={colId} onDragStart={onDragStart} />)}
      {adding ? (
        <div>
          <textarea value={text} onChange={e => setText(e.target.value)} autoFocus />
          <button onClick={handleAdd}>Add</button>
          <button onClick={() => setAdding(false)}>Cancel</button>
        </div>
      ) : (
        <button onClick={() => setAdding(true)}>+ Add card</button>
      )}
    </div>
  )
}
// In KanbanBoard
const onAddCard = (colId, text) => {
  const newCard = { id: `c${Date.now()}`, text }
  setBoard(prev => ({
    ...prev,
    [colId]: {
      ...prev[colId],
      cards: [...prev[colId].cards, newCard]
    }
  }))
}

Each column has an inline “Add card” form. The form appears on click and hides on cancel or submit. Unique IDs use timestamps. The board state updates immutably.

Best Practice Note

This is the same Kanban architecture we use in CoreUI project management templates. For production apps, replace HTML5 drag-and-drop with @dnd-kit/core for better touch support, accessibility, and smoother animations. Persist board state to localStorage or a backend API. Add card editing, labels, due dates, and assignments for richer project management. Consider card ordering within columns using index-based logic for precise positioning. For multi-user boards, implement optimistic updates and WebSocket sync to reflect other users’ changes in real time.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.